/* Twidor - The twiddler tutor (among other things).
 * Copyright (C) 2003 James Fusia
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.util.*;
import java.io.*;

public class FileGenerator
{
	public ArrayList getStats(String username, ArrayList statsFilters) {
		StatsBrowser browser = new StatsBrowser();
		browser.username = username;

		ArrayList ret = new ArrayList();

		ArrayList folders = getSessionFolders(browser);
		Iterator it = folders.iterator();
		while (it.hasNext()) {
			String folder = (String) it.next();

			String [] blockFolders = new File(folder).list();
			if (blockFolders == null) continue;

			Arrays.sort(blockFolders);
			for (int block = 0; block < blockFolders.length; block++) {
				String blockFolder = folder + File.separator + blockFolders[block];
				String [] sentenceFiles = new File(blockFolder).list();
				Arrays.sort(sentenceFiles);
			sentenceLoop:
				for (int sentence = 0; sentence < sentenceFiles.length; sentence++) {
					String sentenceFile = blockFolder + File.separator + sentenceFiles[sentence];

					Stats stats = null;
					Iterator filterIt = statsFilters.iterator();
					while (filterIt.hasNext()) {
						StatsFilter filter = (StatsFilter) filterIt.next();
						stats = filter.filter(sentenceFile, stats);
						if (stats == null) {
							if (filter.appliesToBlock()) {
								break sentenceLoop;
							} else {
								break;
							}
						}
					}
					if (stats != null) {
						ret.add(stats);
					}
				}
			}
		}
		return ret;
	}

	private ArrayList getSessionFolders(StatsBrowser browser) {
		File file = new File(browser.userPath());
		String [] sessionFolders = file.list(new FilenameFilter() {
			public boolean accept(File dir, String name) {
				return name.startsWith("Session");
			}
		});

		String userPath = browser.userPath();
		ArrayList ret = new ArrayList();
		for (int i=0; i<sessionFolders.length; i++) {
			ret.add(userPath + File.separator + sessionFolders[i]);
		}
		
		return ret;
	}

	/*
	private ArrayList getSessionFolders(StatsBrowser browser) {
		ArrayList ret = new ArrayList();
		ret.add(browser.userPath() + File.separator + "ChordingTimingData");
		
		return ret;
	}
	*/
}
