/* Twidor - The twiddler tutor (among other things).
 * Copyright (C) 2003 James Fusia
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.io.*;

public class StudyUser
{
	public String username;
	public String phone;
	public boolean chording_first = true;
	public int sessionNumber;
	public long sessionStarted;
	public String type;

	public StudyUser()
	{

	}

	public boolean saveToFile() {
		try {
			File userFile = new File(userFile(username));
			PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(userFile)));

			out.println(username);
			out.println(phone);
			//if (chording_first) out.println("A");
			//else out.println("B");
			out.println(type);
			out.println(sessionNumber);

			out.close();

			return true;
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Unable to create user file.");
			return false;
		}
	}

	public static StudyUser readFromFile(String username) {
		try {
			File userFile = new File(userFile(username));
			BufferedReader in = new BufferedReader(new FileReader(userFile));

			String fileUsername = in.readLine();
			String filePhone = in.readLine();
			String type = in.readLine();
			String sessionString = in.readLine();
			int sessionNumber;
			try {
				sessionNumber = Integer.parseInt(sessionString);
			} catch (NumberFormatException e) {
				sessionNumber = 0;
			}


			in.close();

			if (!fileUsername.equals(username)) {
				System.out.println("ERROR: username (" + fileUsername +
					") in file didn't match filename (" + username + ").");
				return null;
			}

			StudyUser user = new StudyUser();
			user.username = username;
			user.phone = filePhone;
			user.type = type;
			user.chording_first = type.equals("A");
			if (sessionNumber % 2 == 1) user.chording_first = !user.chording_first;
			
			user.sessionNumber = sessionNumber;

			return user;

		} catch (IOException e) {
			if (TwidorConstants.bDEBUG) {
				e.printStackTrace();
				System.out.println();
			} 
			System.out.println("ERROR: Unable to read user file:" + username);
			return null;
		}
	}

	public static String userFile(String username) {
		return TwidorConstants.PATH_TO_DATA + username + ".txt";
	}
}
