/* Twidor - The twiddler tutor (among other things).
 * Copyright (C) 2003 James Fusia
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
import java.awt.Color;
/**
 * CCG: Twidor- The Twiddler Tutor!
 * <pre>
 * TwidorConstants.java, the file where we make a whole bunch of silly things
 * static. Like Color. And Title. Bleh.
 * How dare you write Easily Maintained code!
 *
 * Revisions:
 *		0.5	17 July 2003
 *		Completed Tutor
 *		0.1	22 May 2003
 * 		Created interface TwidorConstants
 * </pre>
 * @author <a href="mailto:visyz@cc.gatech.edu">Gibby Fusia</a>
 * @version Version 0.5; 17 July 2003
 */
public class TwidorConstants {

	/**
	 * default constructor
	 */
	public TwidorConstants () {
		if (bDEBUG) System.out.println("TwidorConstants created.");
	}// end TwidorConstants ()

	/**
	 * Debug Variable
	 */
	public static boolean bDEBUG = false;

	/**
	 * Window Attributes
	 */
	public static final String WINDOW_TITLE = "Twidor: The Twiddler Tutor!";
	public static int WINDOW_X = 640;
	public static int WINDOW_Y = 400;
	public static final int TWIDDLER_X = 120;
	public static final Color WINDOW_BACKGROUND = Color.white;
	public static final boolean WINDOW_RESIZABLE = false;

	/**
	 * button attributes
	 */
	/*
	public static final int BUTTON_X = (TWIDDLER_X - 30) / 6;
	public static final int BUTTON_Y = WINDOW_Y * 2 / 15; // 2/3 of 1/4 of 4/5 of windowY
	*/
	public static final int BUTTON_X = 14;// width
	public static final int BUTTON_Y = 44;// height
	public static final Color BUTTON_BACKGROUND = Color.LIGHT_GRAY;
	public static final Color BUTTON_HIGHLIGHT = Color.yellow;
	public static final Color TWIDDLER_BACKGROUND = new Color(200, 200, 200); 

	public static final Color COLOR_GREEN = new Color(0, 170, 0);
	
	/**
	 * icons
	 */
	public static final String ICON_RED = "red.gif";
	public static final String ICON_BLUE = "blue.gif";
	public static final String ICON_GREEN = "green.gif";
	
	/**
	 * character colors
	 */
	public static final Color TEXT_DEFAULT = Color.BLACK;
	public static final Color TEXT_ERROR = Color.RED;
	public static final Color TEXT_GOOD = Color.GRAY;
	public static final Color TEXT_BLINK = Color.BLUE;
	public static final Color TEXT_BACKGROUND = Color.WHITE;
	public static final Color TEXT_CURSOR = Color.BLUE;
	public static final String CURSOR = "_";

	/**
	 * Files that are searched for by the program when none are specified
	 */
	public static String DEFAULT_KEYMAP = "thadmap.txt";
	//public static String DEFAULT_KEYMAP = "keymap.txt";
	public static String DEFAULT_PHRASES = "phrases.txt";
	public static boolean DEFAULT_THUMB_ORIENTATION = true;
	public static boolean DEFAULT_FINGER_ORIENTATION = true;

	/**
	 * Serial port settings
	 */
	public static boolean USE_SERIAL = false;
	public static String SERIAL_DEVICE = "/dev/ttyS0";
	public static int SERIAL_BAUD_RATE = 2400;
	public static int SERIAL_TIMEOUT = 2000; // ms

	/**
	 * Multi-tap settings
	 */
	public static boolean USE_MULTITAP = false;
	public static int MULTITAP_TIMEOUT = 1500; // ms

	/**
	 * Keyboard settings
	 */
	public static boolean ALLOW_KEYBOARD = false;
	public static boolean ALLOW_MCC = true;			// Allow multi-character chords

	public static final int INPUT_TWIDDLER = 0;
	public static final int INPUT_MULTITAP = 1;
	public static final int INPUT_KEYBOARD = 2;

	/**
	 * Highlighting settings
	 */
	public static int HIGHLIGHT_DELAY = 3000; // ms
	public static boolean HIGHLIGHT_HINT = true; // before
	public static boolean HIGHLIGHT_POST = false; // after
	public static boolean HIGHLIGHT_MACRO = false; // look for macros
	public static boolean HIGHLIGHT_ERRORS = true;

	/**
	 * In-program settings
	 */
	public static boolean MENUBAR_SHOW = true;

	public static final String TWIDDLER_SHOW_TEXT = "Show Twiddler";
	public static boolean TWIDDLER_SHOW = true;
	public static final String TWIDDLER_SHOW_LETTERS_TEXT = "Show Twiddler Letters";
	public static boolean TWIDDLER_SHOW_LETTERS = true;
	public static final String TWIDDLER_MIRROR_TEXT = "Mirror Twiddler";
	public static boolean TWIDDLER_MIRROR = false;

	public static final String HIGHLIGHT_HINT_TEXT = "Highlight Hint";
	public static final String HIGHLIGHT_POST_TEXT = "Highlight Keypress";
	public static final String HIGHLIGHT_MACRO_TEXT = "Highlight Macros";

	public static final String HIGHLIGHT_ERRORS_TEXT = "Highlight Errors";

	public static final String ALLOW_ERRORS_TEXT = "Allow Uncorrected Errors";
	public static boolean ALLOW_ERRORS = true;
	public static boolean ALLOW_EARLY_ENTER = false;
	public static int HOW_EARLY_ENTER_ALLOWED = 4;

	public static final String STATS_SHOW_TEXT = "Show Stats";
	public static boolean STATS_SHOW = true;
	public static final String LOG_ENABLE_TEXT = "Allow Logging";
	public static boolean LOG_ENABLE = false;
	public static final String LOG_FILE_TEXT = "Log Name";
	public static String LOG_FILE = null;

	public static final String START_TEXT = "Show Sentence";
	public static final String START_FROM_TEXT = "Specify Sentence";
	public static final String STOP_TEXT = "Stop Input";
	public static final String QUIT_TEXT = "Quit";

	/**
	 * For consistency when accessing the KeyElement button Vector.
	 */
	public static final int FINGER_OFFSET = 3;
	public static final int INDEX_OFFSET = 0;
	public static final int MIDDLE_OFFSET =  3;
	public static final int RING_OFFSET = 6;
	public static final int PINKY_OFFSET = 9;
	public static final int THUMB_OFFSET = 12;

	public static final int B_NUM = 0;
	public static final int B_ALT = 1;
	public static final int B_CTRL = 2;
	public static final int B_SHIFT = 3;

	public static final int B_LEFT = 0;
	public static final int B_MIDDLE = 1;
	public static final int B_RIGHT = 2;
	public static final int B_NONE = -1;

	/**
	 * And because they might change...
	 */
	public static final int KEY_BACKSPACE = 8;
	public static final int KEY_ENTER = 13;
	public static final int KEY_SPACE = 32;
	public static final int KEY_DELETE = 127;
	/* I'm not sure why this is different from KEY_ENTER, but it makes a
	 * difference */
	public static final int KEY_EOL = 10;
	public static final int KEY_NOT_A_KEY = -255;
	public static final int KEY_MULTITAP = -254;
	/* directional keys */
	public static int KEY_LEFT = 42;
	public static int KEY_RIGHT = 35;
	public static int KEY_MENTER = 48;

	/**
	 * Constants specific to study procedure
	 */
	public static boolean RUNNING_STUDY = false;
	public static boolean TIMING_DATA = false;
	public static boolean DO_KEYBOARD = false;
	public static long timingStarted = 0;
	public static boolean STUDY_DO_MULTI_TAP = true;
	public static int sessionNumber = 0;

	public static StudyUser user = null;
	public static int currentState;

	public static final int STATE_KEYBOARD = 0;
	public static final int STATE_WARMUP = 1;
	public static final int STATE_BLOCK = 2;
	public static final int STATE_ENDED = 3;

	public static String PATH_TO_DATA = "data" + java.io.File.separator;

	public static final int CODE_NEXT_SENTENCE = 0;
	public static final int CODE_NEXT_BLOCK = 1;
	public static final int CODE_SWITCH_INPUTS = 2;
	public static final int CODE_END = 3;

	public static final int SENTENCE_ALPHA1 = -1;
	public static final int SENTENCE_ALPHA2 = -2;

	/**
	 * Since I've made this an instance class that everybody sees,
	 * this now holds a couple instance variables that I had trouble
	 * passing between the various programs
	 */
	public static TwidorCallbacks callbacks;

	public static int SENTENCE_NUMBER = -1; 
	public static int CHARACTER_NUMBER = -1;
	public static boolean ACCEPT_INPUT = false;

	public static Sentence sentenceList;

}// end class TwidorConstants
